//+------------------------------------------------------------------+
//|                                                     smoothed rsi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int  Length = 14;
extern int  Price  = PRICE_TYPICAL;
extern bool Smooth = true;

//
//
//
//
//

double rsi[];
double prc[];
double buff[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,prc);
   SetIndexBuffer(2,buff);

   //
   //
   //
   //
   //
   
   string PriceType;
      switch(Price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }      

   //
   //
   //
   //
   //

   Length = MathMax(Length ,1);
   string addName = "";
      if (Smooth) addName = "smoothed ";
   IndicatorShortName (" RSI "+addName+"("+Length+","+PriceType+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   for(i=limit; i >= 0; i--)
   {
      prc[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
      //
      //
      //
      //
      //
      
      if (i>=Bars-Length) continue;

         //
         //
         //
         //
         //
         
         double cu = 0;
         double cd = 0;
         for (int k=0; k<Length; k++)
            {
               double diff = prc[i+k]-prc[i+k+1];
                  if (diff > 0) cu += diff;
                  if (diff < 0) cd -= diff;
            }
         if ((cu+cd)!=0)
               buff[i] = 50.0*((cu-cd)/(cu+cd)+1.0);
         else  buff[i] = 0;
         if (Smooth)
               rsi[i] = (buff[i] + 2.0*buff[i+1] + buff[i+2])/4.0;
         else  rsi[i] = (buff[i]);
   }
   return(0);
}